Index: branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/limmp.F90
===================================================================
--- branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/limmp.F90	(revision 8592)
+++ branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/limmp.F90	(revision 8597)
@@ -7,6 +7,4 @@
    !!            1.0  ! 2012    (O. Lecomte) Adaptation for scientific tests (NEMO3.1)
    !!            2.0  ! 2017    (M. Vancoppenolle, O. Lecomte, C. Rousset) Implementation in NEMO3.6
-   !!                 ! NB: Only lim_mp_cstt and lim_mp_cesm work in this
-   !!                       version
    !!----------------------------------------------------------------------
 #if defined key_lim3
@@ -16,18 +14,8 @@
    !!   lim_mp_init      : some initialization and namelist read
    !!   lim_mp           : main calling routine
-   !!   lim_mp_topo      : main melt pond routine for the "topographic" formulation (FloccoFeltham)
-   !!   lim_mp_area      : ??? compute melt pond fraction per category
-   !!   lim_mp_perm      : computes permeability (should be a FUNCTION!)
-   !!   calc_hpond       : computes melt pond depth
-   !!   permeability_phy : computes permeability
-
    !!----------------------------------------------------------------------
    USE phycst           ! physical constants
    USE dom_oce          ! ocean space and time domain
-!  USE sbc_ice          ! Surface boundary condition: ice   fields
    USE ice              ! LIM-3 variables
-!  USE icecons          ! conservation tests
-!  USE limctl           ! control prints
-!  USE limvar
    !
    USE lbclnk           ! lateral boundary conditions - MPP exchanges
@@ -37,24 +25,4 @@
    USE timing           ! Timing
 
-!OLI_CODE    USE ice_oce, ONLY: rdt_ice, tatm_ice
-!OLI_CODE    USE phycst
-!OLI_CODE    USE dom_ice
-!OLI_CODE    USE dom_oce
-!OLI_CODE    USE sbc_oce
-!OLI_CODE    USE sbc_ice
-!OLI_CODE    USE par_ice
-!OLI_CODE    USE par_oce
-!OLI_CODE    USE ice
-!OLI_CODE    USE thd_ice
-!OLI_CODE    USE in_out_manager
-!OLI_CODE    USE lbclnk
-!OLI_CODE    USE lib_mpp
-!OLI_CODE 
-!OLI_CODE    IMPLICIT NONE
-!OLI_CODE    PRIVATE
-!OLI_CODE 
-!OLI_CODE    PUBLIC   lim_mp_init
-!OLI_CODE    PUBLIC   lim_mp
-
    IMPLICIT NONE
    PRIVATE
@@ -62,4 +30,10 @@
    PUBLIC   lim_mp_init    ! routine called by icestp.F90
    PUBLIC   lim_mp         ! routine called by icestp.F90
+
+   INTEGER ::              nice_pnd   ! choice of the type of pond scheme
+   !                                               ! associated indices:
+   INTEGER, PARAMETER ::   np_pndNO  = 0   ! No pond scheme
+   INTEGER, PARAMETER ::   np_pndCST = 1   ! Constant pond scheme
+   INTEGER, PARAMETER ::   np_pndH12 = 2   ! Evolutive pond scheme (Holland et al. 2012)
 
    !! * Substitutions
@@ -71,79 +45,4 @@
    !!----------------------------------------------------------------------
 CONTAINS
-
-   SUBROUTINE lim_mp_init 
-      !!-------------------------------------------------------------------
-      !!                  ***  ROUTINE lim_mp_init   ***
-      !!
-      !! ** Purpose : Physical constants and parameters linked to melt ponds
-      !!      over sea ice
-      !!
-      !! ** Method  :  Read the nammp  namelist and check the melt pond  
-      !!       parameter values called at the first timestep (nit000)
-      !!
-      !! ** input   :   Namelist nammp  
-      !!-------------------------------------------------------------------
-      INTEGER  ::   ios                 ! Local integer output status for namelist read
-      NAMELIST/nammp/  ln_pnd, ln_pnd_rad, ln_pnd_fw, nn_pnd_scheme, rn_apnd, rn_hpnd
-      !!-------------------------------------------------------------------
-
-      REWIND( numnam_ice_ref )              ! Namelist nammp  in reference namelist : Melt Ponds  
-      READ  ( numnam_ice_ref, nammp, IOSTAT = ios, ERR = 901)
-901   IF( ios /= 0 ) CALL ctl_nam ( ios , 'nammp  in reference namelist', lwp )
-
-      REWIND( numnam_ice_cfg )              ! Namelist nammp  in configuration namelist : Melt Ponds
-      READ  ( numnam_ice_cfg, nammp, IOSTAT = ios, ERR = 902 )
-902   IF( ios /= 0 ) CALL ctl_nam ( ios , 'nammp in configuration namelist', lwp )
-      IF(lwm) WRITE ( numoni, nammp )
-      
-      IF(lwp) THEN                        ! control print
-         WRITE(numout,*)
-         WRITE(numout,*) 'lim_mp_init : ice parameters for melt ponds'
-         WRITE(numout,*) '~~~~~~~~~~~~'
-         WRITE(numout,*) '   Active melt ponds                                           ln_pnd        = ', ln_pnd
-         WRITE(numout,*) '   Active melt ponds radiative coupling                        ln_pnd_rad    = ', ln_pnd_rad
-         WRITE(numout,*) '   Active melt ponds freshwater coupling                       ln_pnd_fw     = ', ln_pnd_fw
-         WRITE(numout,*) '   Type of melt pond scheme =0 presc, =1 empirical = 2 topo    nn_pnd_scheme = ', nn_pnd_scheme
-         WRITE(numout,*) '   Prescribed pond fraction                                    rn_apnd       = ', rn_apnd
-         WRITE(numout,*) '   Prescribed pond depth                                       rn_hpnd       = ', rn_hpnd
-      ENDIF
-
-      IF ( .NOT. ln_pnd ) THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) ' Melt ponds are not activated '
-         IF(lwp) WRITE(numout,*) ' ln_pnd_rad and ln_pnd_fw set to .FALSE. '
-         IF(lwp) WRITE(numout,*) ' nn_pnd_scheme, rn_apnd, rn_hpnd set to zero '
-         ln_pnd_rad    = .FALSE.
-         ln_pnd_fw     = .FALSE.
-         nn_pnd_scheme = 0
-         rn_apnd       = 0._wp
-         rn_hpnd       = 0._wp
-
-         IF(lwp) THEN                     ! control print
-            WRITE(numout,*) '    Active melt ponds radiative coupling                        ln_pnd_rad    = ', ln_pnd_rad
-            WRITE(numout,*) '    Active melt ponds freshwater coupling                       ln_pnd_fw     = ', ln_pnd_fw
-            WRITE(numout,*) '    Type of melt pond scheme =0 presc, =1 empirical = 2 topo    nn_pnd_scheme = ', nn_pnd_scheme
-            WRITE(numout,*) '    Prescribed pond fraction                                    rn_apnd       = ', rn_apnd
-            WRITE(numout,*) '    Prescribed pond depth                                       rn_hpnd       = ', rn_hpnd
-         ENDIF
-      ENDIF
-
-      IF ( ln_pnd .AND. ( nn_pnd_scheme == 0 ) .AND. ( ln_pnd_fw ) ) THEN
-         IF(lwp) WRITE(numout,*) ' Prescribed melt ponds do not conserve fresh water mass, hence ln_pnd_fw must be set to false ' 
-         ln_pnd_fw     = .FALSE.
-         IF(lwp) THEN                     ! control print
-            WRITE(numout,*) '    Active melt ponds freshwater coupling                       ln_pnd_fw     = ', ln_pnd_fw
-         ENDIF
-      ENDIF
-
-      IF ( ln_pnd .AND. ( nn_pnd_scheme == 2 ) .AND. ( jpl == 1 ) ) THEN
-         IF(lwp) WRITE(numout,*) ' Topographic melt ponds are incompatible with jpl = 1 '
-         IF(lwp) WRITE(numout,*) ' Run aborted '
-         CALL ctl_stop( 'STOP', 'lim_mp_init: uncompatible options, reset namelist_ice_ref ' )
-      ENDIF
-
-      !
-   END SUBROUTINE lim_mp_init
-   
 
    SUBROUTINE lim_mp( kt )
@@ -158,29 +57,20 @@
       !!              - 
       !!------------------------------------------------------------------------------------
-
-      INTEGER, INTENT(in) :: kt    ! number of iteration
-      INTEGER  ::   ji, jj, jl     ! dummy loop indices
-
+      INTEGER, INTENT(in) ::   kt    ! number of iteration
+      INTEGER ::   ji, jj, jl     ! dummy loop indices
       !!-------------------------------------------------------------------
 
       IF( nn_timing == 1 )  CALL timing_start('lim_mp')
 
-      SELECT CASE ( nn_pnd_scheme )
-
-         CASE (0)
-
-            CALL lim_mp_cstt       ! staircase melt ponds
-
-         CASE (1)
-
-            CALL lim_mp_cesm       ! empirical melt ponds
-
-         CASE (2)
-
-            CALL lim_mp_topo   &   ! topographic melt ponds 
-                      &          (at_i, a_i,                                       &
-                      &          vt_i, v_i, v_s,            t_i, sz_i, a_ip_frac,   &
-                      &          h_ip,     t_su)
-
+      SELECT CASE ( nice_pnd )
+
+      CASE (np_pndCST)
+         !                             !------------------------------!
+         CALL lim_mp_CST               ! Constant melt ponds          !
+         !                             !------------------------------!
+      CASE (np_pndH12)
+         !                             !------------------------------!
+         CALL lim_mp_H12               ! Holland et al 2012 melt ponds!
+         !                             !------------------------------!
       END SELECT
 
@@ -189,7 +79,7 @@
    END SUBROUTINE lim_mp 
 
-   SUBROUTINE lim_mp_cstt 
-       !!-------------------------------------------------------------------
-       !!                ***  ROUTINE lim_mp_cstt  ***
+   SUBROUTINE lim_mp_CST 
+       !!-------------------------------------------------------------------
+       !!                ***  ROUTINE lim_mp_CST  ***
        !!
        !! ** Purpose    : Compute melt pond evolution
@@ -206,11 +96,7 @@
        !!    
        !!-------------------------------------------------------------------
-       INTEGER                             :: ji, jj, jl
-       REAL(wp)                            :: z1_jpl            ! 1/jpl
-       !!-------------------------------------------------------------------
-
-       z1_jpl     = 1. / FLOAT(jpl)
 
        WHERE ( ( a_i > epsi10 ) .AND. ( t_su >= rt0-epsi06 ) ) 
+!!       WHERE ( ( a_i > 0._wp ) .AND. ( t_su >= rt0 ) ) 
           a_ip_frac = rn_apnd
           h_ip      = rn_hpnd    
@@ -226,9 +112,9 @@
        wfx_pnd(:,:) = 0._wp
 
-   END SUBROUTINE lim_mp_cstt
-
-   SUBROUTINE lim_mp_cesm
-       !!-------------------------------------------------------------------
-       !!                ***  ROUTINE lim_mp_cesm  ***
+   END SUBROUTINE lim_mp_CST
+
+   SUBROUTINE lim_mp_H12
+       !!-------------------------------------------------------------------
+       !!                ***  ROUTINE lim_mp_H12  ***
        !!
        !! ** Purpose    : Compute melt pond evolution
@@ -249,25 +135,25 @@
        !!-------------------------------------------------------------------
 
-       INTEGER, DIMENSION(jpij)         :: indxi             ! compressed indices for cells with ice melting
-       INTEGER, DIMENSION(jpij)         :: indxj             !
-
-       REAL(wp), DIMENSION(jpi,jpj)     :: zwfx_mlw          ! available meltwater for melt ponding
-       REAL(wp), DIMENSION(jpi,jpj,jpl) :: zrfrac            ! fraction of available meltwater retained for melt ponding
-
-       REAL(wp), PARAMETER :: zrmin  = 0.15_wp  ! minimum fraction of available meltwater retained for melt ponding
-       REAL(wp), PARAMETER :: zrmax  = 0.70_wp  ! maximum   ''           ''       ''        ''            ''
-       REAL(wp), PARAMETER :: zrexp  = 0.01_wp  ! rate constant to refreeze melt ponds
-       REAL(wp), PARAMETER :: zpnd_aspect = 0.8_wp ! pond aspect ratio
-
-       REAL(wp) :: zhi               ! dummy ice thickness
-       REAL(wp) :: zhs               ! dummy snow depth
-       REAL(wp) :: zTp               ! reference temperature
-       REAL(wp) :: zdTs              ! dummy temperature difference
-       REAL(wp) :: z1_rhofw          ! inverse freshwater density
-       REAL(wp) :: z1_zpnd_aspect    ! inverse pond aspect ratio
-       REAL(wp) :: zvpold            ! dummy pond volume
-
-       INTEGER  :: ji, jj, jl, ij    ! loop indices
-       INTEGER  :: icells            ! size of dummy array
+       INTEGER, DIMENSION(jpij)         ::   indxi             ! compressed indices for cells with ice melting
+       INTEGER, DIMENSION(jpij)         ::   indxj             !
+
+       REAL(wp), DIMENSION(jpi,jpj)     ::   zwfx_mlw          ! available meltwater for melt ponding
+       REAL(wp), DIMENSION(jpi,jpj,jpl) ::   zrfrac            ! fraction of available meltwater retained for melt ponding
+
+       REAL(wp), PARAMETER ::   zrmin  = 0.15_wp  ! minimum fraction of available meltwater retained for melt ponding
+       REAL(wp), PARAMETER ::   zrmax  = 0.70_wp  ! maximum   ''           ''       ''        ''            ''
+       REAL(wp), PARAMETER ::   zrexp  = 0.01_wp  ! rate constant to refreeze melt ponds
+       REAL(wp), PARAMETER ::   zpnd_aspect = 0.8_wp ! pond aspect ratio
+
+       REAL(wp) ::   zhi               ! dummy ice thickness
+       REAL(wp) ::   zhs               ! dummy snow depth
+       REAL(wp) ::   zTp               ! reference temperature
+       REAL(wp) ::   zdTs              ! dummy temperature difference
+       REAL(wp) ::   z1_rhofw          ! inverse freshwater density
+       REAL(wp) ::   z1_zpnd_aspect    ! inverse pond aspect ratio
+       REAL(wp) ::   zvpold            ! dummy pond volume
+
+       INTEGER  ::   ji, jj, jl, ij    ! loop indices
+       INTEGER  ::   icells            ! size of dummy array
        !!-------------------------------------------------------------------
         z1_rhofw       = 1. / rhofw 
@@ -301,9 +187,7 @@
            ! Identify grid cells where ponds should be updated (can probably be improved)
            !------------------------------------------------------------------------------
- 
            indxi(:) = 0
            indxj(:) = 0
            icells   = 0
- 
            DO jj = 1, jpj
              DO ji = 1, jpi
@@ -313,6 +197,6 @@
                    indxj(icells) = jj
                 ENDIF
-             END DO                 ! ji
-          END DO                    ! jj
+             END DO
+          END DO
  
           DO ij = 1, icells
@@ -331,5 +215,5 @@
                 h_ip(ji,jj,jl)      = 0._wp
  
-                IF ( ln_pnd_fw ) & !--- Give freshwater to the ocean
+                IF ( ln_pnd_fwb ) & !--- Give freshwater to the ocean
                    wfx_pnd(ji,jj)   = wfx_pnd(ji,jj) + v_ip(ji,jj,jl) 
  
@@ -352,5 +236,5 @@
                 !--- Dump meltwater due to refreezing ( of course this is wrong
                 !--- but this parameterization is too simple )
-                IF ( ln_pnd_fw ) &
+                IF ( ln_pnd_fwb ) &
                    wfx_pnd(ji,jj)   = wfx_pnd(ji,jj) + rhofw * ( v_ip(ji,jj,jl) - zvpold ) * r1_rdtice
  
@@ -361,11 +245,4 @@
  
                 a_ip(ji,jj,jl)      = a_ip_frac(ji,jj,jl) * a_i(ji,jj,jl)
- 
-             !-----------------------------------------------------------
-             ! Limit pond depth
-             !-----------------------------------------------------------
-             ! The original version has pond depth limitation, which I did not
-             ! keep here. Maybe we need it later on
-             !
              
              ENDIF
